//
// VirtualFunctions.cpp
//
// LECTURE 11
// DEMO 2
//
// This version implements printPersonInfo with a Pass-By-Value
// parameter
//

#include "StdAfx.h"

#include <iostream>

using namespace std;  //introduces namespace std

#include "Person.h"

// Here's the Student class (derived)
class Student: public Person
{
public:
  void printInfo();
  int  getId() { return studentID; }
private:
  int  studentID;
};


void Student::printInfo()
{
  cout << "Student ID: " << studentID << endl;
}


class Instructor: public Person
{
public:
  int getId() { return employeeID; }
private:
  int employeeID;
};


void printPersonInfo(Person aPerson)
{
  aPerson.printInfo();
}


int main()
{	
  Student aStudent;
  Instructor anInstructor;
    
  // Now set the information.  Remember, setInfo() is 
  // defined in the "Person" class
  cout << "First, the student..." << endl;
  aStudent.setInfo("Joe Student","166 Phelps Lane",
                    "555-1212");
  printPersonInfo(aStudent);
  
  cout << endl << "Now for the instructor: " << endl;
  anInstructor.setInfo("Ron DiNapoli", "120 Maple Ave", "555-1313");
  printPersonInfo(anInstructor);
  return 0;

}

